#include <WiFi.h>
#include <HTTPClient.h>
#include <UrlEncode.h>

#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define ButtonL 13
#define ButtonR 14

#define SCREEN_WIDTH 128
#define SCREEN_HEIGHT 64
Adafruit_SSD1306 display(SCREEN_WIDTH,SCREEN_HEIGHT,&Wire,-1);
const char* ssid =  "REPLACE_WITH_WIFI_USERNAME";
const char* password = "REPLACE_WITH_WIFI_PASSWORD";

// +international_country_code + phone number
// Portugal +351, example: +351912345678
String phoneNumber = "REPLACE_WITH_PHONE_NUMBER";
String apiKey = "REPLACE_WITH_API_KEY";

unsigned long counter;
unsigned long counterPrev;
int buttonL;
int buttonR;
int buttonLprev;
int buttonRprev;
int timerSecs = -1;
int timerMins = 0;

void sendMessage(String message){

  // Data to send with HTTP POST
  String url = "https://api.callmebot.com/whatsapp.php?phone=" + phoneNumber + "&apikey=" + apiKey + "&text=" + urlEncode(message);    
  HTTPClient http;
  http.begin(url);

  // Specify content-type header
  http.addHeader("Content-Type", "application/x-www-form-urlencoded");
  
  // Send HTTP POST request
  int httpResponseCode = http.POST(url);
  if (httpResponseCode == 200){
    Serial.print("Message sent successfully");
  }
  else{
    Serial.println("Error sending the message");
    Serial.print("HTTP response code: ");
    Serial.println(httpResponseCode);
  }

  // Free resources
  http.end();
}
void setup() {
  // put your setup code here, to run once:
  pinMode(ButtonL, INPUT_PULLUP);
  pinMode(ButtonR, INPUT_PULLUP);
  Serial.begin(115200);
  
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)){
    Serial.println("SSD1306 allocation failed");
    for(;;);
  }
  delay(2000);

  WiFi.begin(ssid, password);
  Serial.println("Connecting");
  while(WiFi.status() != WL_CONNECTED){
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.print("Connected to WiFi network with IP Address: ");
  Serial.println(WiFi.localIP());
}

void loop() {
  // put your main code here, to run repeatedly:
  counter = millis();
  buttonL = digitalRead(ButtonL);
  buttonR = digitalRead(ButtonR);
  if (buttonLprev == HIGH && buttonL == LOW){Serial.println("pressedL"); timerMins = 0; timerSecs = -1;}
  if (buttonRprev == HIGH && buttonR == LOW){Serial.println("pressedR"); timerMins+=1; timerSecs = 0;}
  buttonLprev = buttonL;
  buttonRprev = buttonR;
  display.clearDisplay();
  display.setTextSize(3);
  display.setTextColor(WHITE);
  display.setCursor(40,10);
  display.println(timerMins);
  display.setCursor(40,40);
  display.println(timerSecs);
  display.display();
  if (counter - counterPrev >= 1000){
    if (timerSecs == 0 && timerMins != 0){
      timerMins -= 1;
      timerSecs = 59;
    } else if (timerSecs != 0 && timerSecs != -1){
      timerSecs -= 1;
    } else if (timerSecs == 0 && timerMins == 0){
      Serial.println("Done");
      sendMessage("Your timer has ended.");
      timerSecs = -1;
    }
    counterPrev = counter;
  }
}
